



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Easy Summation</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Easy Summation</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 21:59:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>Description</p>
<div>
<div>You are encountered with a traditional problem concerning the sums of powers.&nbsp;<br />Given two integers $n$ and $k$. Let $f(i)=i^k$, please evaluate the sum $f(1)+f(2)+...+f(n)$. The problem is simple as it looks, apart from the value of $n$ in this question is quite large.&nbsp;<br />Can you figure the answer out? Since the answer may be too large, please output the answer modulo $10^9+7$.</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p>Input</p>
<div>
<div>The first line of the input contains an integer $T(1\leq T\leq20)$, denoting the number of test cases.&nbsp;<br />Each of the following $T$ lines contains two integers $n(1\leq n\leq 10000)$ and $k(0\leq k\leq 5)$.&nbsp;</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p>Output</p>
<div>
<div>For each test case, print a single line containing an integer modulo $10^9+7$.</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p>Sample Input</p>
<div>
<div>
<div>3
</div>
<div>2 5
</div>
<div>4 2
</div>
<div>4 1 </div>
</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p>Sample Output</p>
<div>
<div>
<div>33
</div>
<div>30
</div>
<div>10</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><strong>题目意思：</strong>给定两个数n,k。求1的k次方 + 2的k次方 + ....+ n的k次方。结果会很大，所以要对10的9次方+7取余。</div>
<div>&nbsp;</div>
<div><strong>解题思路：</strong>把1-n的每个数的k次方加起来，求幂的时候使用快速幂，值得一提的是数非常大，因此在快速幂求幂的过程中， 每一步也要对10的9次方+7取余。</div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;stdio.h&gt;<br />
 #define MAX 1000000007<br />
 #define ll long long int<br />
 ll test(int n,int k)<br />
 {<br />
     ll i,t;<br />
     t=;<br />
     for(i=; i&lt;=k; i++)<br />
     {<br />
         t=(t*n)%MAX;<br />
     }<br />
     return t;<br />
 }<br />
 int main()<br />
 {<br />
     ll n,k,sum,i,t;<br />
     while(scanf("%lld",&amp;t)!=EOF)<br />
     {<br />
         while(t--)<br />
         {<br />
             sum=;<br />
             scanf("%lld%lld",&amp;n,&amp;k);<br />
             for(i=; i&lt;=n; i++)<br />
             {<br />
                 sum=(sum+test(i,k))%MAX;<br />
             }<br />
             printf("%lld\n",sum);<br />
         }<br />
     }<br />
     return ;<br />
 }</pre>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ovkxlq.html">国家以及国家语言的json数据格式，提供给网友参考。</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnw513q.html">GNS3 桥接虚拟网卡 telnet 实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/r936x3w9.html">UITableView代理方知多少&plus;执行顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ek20z8.html">RDIFramework&period;NET（&period;NET快速开发框架） 答客户问（2014-02-23）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvwlnj9.html">IOS 键盘 禁止输入字母</a>
		</li>
						<li><a href="https://www.batexi.com/a/49glwweq.html">大牛之路II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdr53k8.html">混乱的url编码&vert;&vert;URL编码解码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdlxd78.html">office2010怎么激活</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1xgn28.html">&lbrack;oracle安装错误处理&rsqb;ORA-00600&colon; &lbrack;keltnfy-ldmInit&rsqb;&lbrack;46&rsqb;&comma; &lbrack;1&rsqb;&comma; &lbrack;&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x26mv8.html">CPU性能测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj1gv5q.html">Linux：最终用途cat命令查看不可见的字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p3zxj8.html">epoll完整例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1kg7xq.html">cycript</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey34mz9.html">ThreadLocal类分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pvwzj8.html">快排实现仿order by多字段排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yed5r8.html">什么是LogDashboard？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7z75q.html">微信支付没有结果通知&comma;notify&lowbar;url参数的接口没有收到微信支付结果通知</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j11pr09.html">包建强的培训课程（14）：Android与ReactNative</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ogyex8.html">server后台TCP连接存活问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jo733q.html">HeadFirst Ruby 第十四章总结 Web apps&colon; Serving HTML</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96m3y638.html">ABAP术语-SAP GUI for HTML</a>
			</li>
						<li><a href="https://www.batexi.com/a/8od43kxq.html">jquery 插件学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/95p3z00q.html">Spring MVC 的核心应用-1</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15vy269.html">obfuscator-llvm Theos 集成配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mdjxpr8.html">Flume：source和sink</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r4nwk78.html">hadoop jobhistory访问界面长时间打不开</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e0mxkxq.html">KEIL MDK-ARM Version 5&period;26正式版开发工具下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/8od4ompq.html">java 用接口计算圆柱的体积和面积并添加颜色</a>
			</li>
						<li><a href="https://www.batexi.com/a/90d25on8.html">OpenCV代码提取：dft函数的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxl23wvq.html">笔记：ndk-stack和addr2line</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
